

      PROGRAM MAIN

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      CHARACTER *80 smieci
 	INTEGER i,NUMITER,licziter
	INTEGER Cm1,Cm2
      DIMENSION YOUNG(100000)
	DIMENSION TH(100000)      
	DIMENSION NBR(26,100000)
	DIMENSION DCOMP(100000),DCOMP0(100000),XNEW(100000)
	DIMENSION pow(100000),licznbr(100000),pow1(100000)
            DIMENSION ComplSort(100000,2)
            DIMENSION CC(100000)
            DIMeNSION SUMnbCC(100000),sumcc(100000)
            DIMENSION CCnrel(100000),ymass(100000)
            dimension sdcomp(100000,2)
            
!     max number of iterations
      licziter=50    
!     current number of iteration
      open(77,file='iter')
	READ(77,*)NUMITER
	close (77)
!     LEL - number of elements
!     lopt - max number of optimized elements - without non optimized region 
!     areaALL - area of structure
!     YOUNG01 - Young modulus of the material
      LEL=16304
      lopt=11393
      areaALL=24958.9 
      YOUNG01=2.1e5
!     PENAL- penalty factor for SIMP
	PENAL=3
!     Volfrac - volume fraction
      Volfrac=0.4
!     initial, minimal and maximal value of design variables
      TH0=0.4
      THMIN=0.001
      THMAX=1.0
      if (NUMITER.eq.1) then
      DO 100 NE=1,LEL
  100 TH(NE)=TH0
      end if
!     read updated design variables     
	if (NUMITER.gt.1) then
      open(99,file='THnew')
	do NE=1,LEL,1
      read(99,*)TH(NE)
	end do
      close (99)
	end if
!     for nonoptimized region
	do ne=lopt+1,lel
	th(ne)=1.0
	enddo
!     area (volume for 3D) of elements - from Ansys output data	
      open(32,file='volu')
	do i=1,5
	read(32,fmt='(a80)')smieci
	end do
	read(32,*)(pow(NE),NE=1,lel)
      close (32)
      do ne=1,lel
      pow1(ne)=pow(ne)/areaALL
      end do
!     neighbors and number of neighbors
      open(12,file='neighbors')
      do NE=1,lel
      read(12,*)nr,nbr(1,ne),nbr(2,ne),nbr(3,ne),
     *nbr(4,ne),nbr(5,ne)
      end do
      close (12)
      open(10,file='n_neighbors')
      do NE=1,lel
      read(10,*)licznbr(ne)
      end do
      close (10)
!     strain energy for elements   - from Ansys output data
      open(55,file='StrainEn')
	do i=1,5
	read(55,fmt='(a80)')smieci
	end do
	read(55,*)(Dcomp(NE),NE=1,lel)
	close (55)
	do NE=1,lel
	dcomp(NE)=2*dcomp(NE)
	end do
!     total compliance at the current iteration stored in external file
   	TOTCOMP=0.0
      DO NE=1,LEL
      TOTCOMP=TOTCOMP+(TH(NE)**PENAL)*DCOMP(NE)
      END DO
      open(20,file='totcompl',position="append")
	write(20,*)numiter,totcomp
      close (20)
!     local average compliance 
      DO 438 NE=1,LEL
  438 DCOMP0(NE)=DCOMP(NE)
      DO 440 NE=1,LEL
      SUM=0.0
      NUMSUM=0
      NUMNBR=licznbr(ne)
      DO 441 NB=1,NUMNBR
      IF(TH(NBR(NB,NE)).GT.0.0)THEN
      NUMSUM=NUMSUM+1
      SUM=SUM+DCOMP0(NBR(NB,NE))
      ENDIF      
  441 CONTINUE
      DCOMP(NE)=(SUM+dcomp0(ne))/FLOAT(NUMSUM+1)
  440 CONTINUE 
!*******************************************************************
!*******************************************************************
!     CAmCB algorithm
      Nmn=0.02*lel
      Nmx=0.98*lel
      Cm1=1
      Cm2=1
      AB=0.0
      alpha_=1
      if(NUMITER.gt.25)Nmn=(lel*0.5)
      if(NUMITER.gt.50)Nmn=(lel*0.75)
!   
      do i=1,lel
      call srand(22231+i+NUMITER)
      ymass(i)=pow1(i)*
     *((1.0+0.05*(1-((numiter-1)/licziter-1))*(2*rand(0)-1)))
      end do     
!
      do i=1,Nmn
      cc(i)=-Cm1
      end do
!     
      do i=Nmn+1,Nmx
      cc(i)=(float(Cm1)+float(Cm2))*i/
     *(float(Nmx)-float(Nmn))-
     *(float(Cm1)*float(Nmx)+float(Cm2)*float(Nmn))/
     *(float(Nmx)-float(Nmn))
      end do
!            
      do i=Nmx+1,lel
      cc(i)=Cm2
      end do
!
      do i=1,lel
      sdcomp(i,1)=dcomp(i)
      sdcomp(i,2)=i
      enddo
!
      n=lel
      inc=1
    1 inc=3*inc+1
      if(inc.le.n)goto 1
    2 continue 
      inc=inc/3
               do i=inc+1,n 
               v=sdcomp(i,1)
               ii=sdcomp(i,2)
                j=i
    3           if(sdcomp(j-inc,1).gt.v)then 
                 sdcomp(j,1)=sdcomp(j-inc,1)
                 sdcomp(j,2)=sdcomp(j-inc,2)
                 j=j-inc
                 if(j.le.inc)goto 4
                  goto 3
                endif
    4            sdcomp(j,1)=v
                 sdcomp(j,2)=ii
                 enddo
      if(inc.gt.1)goto 2
!
      do i=1,lel
      CCnrel(int(sdcomp(i,2)))=CC(i)
      end do
!*******************************************************************
!     updataing of the design variables including total volume constraint
      THMOVE=0.2
      EP=1.D-6 
      XL=0.0
      XU=100000.
!
  409 CONTINUE
!
      TVOL=0.0          
!
      DO 405 NE=1,lopt
!
      XMID=0.5*(XL+XU)
      XMIN=MAX(THMIN,TH(NE)-THMOVE)
      XMAX=MIN(TH(NE)+THMOVE,THMAX)
!
      NUMNBR=licznbr(ne)
!
      SUMnbCC(ne)=0.0
      do i=1,numnbr
      SUMnbCC(ne)=SUMnbCC(ne)+
     *((alpha_*ymass(nbr(i,ne))-ymass(ne)))*CCnrel(ne)
     *+(1+alpha_)*ymass(nbr(i,ne))*CCnrel(nbr(i,ne))
     */(ymass(ne)+ymass(nbr(i,ne)))
      end do 
!      
      sumcc(ne)=CCnrel(ne)+SUMnbCC(ne)
      avrV=sumcc(ne)/(NUMNBR+1)
!            
      XNEW(NE)=TH(NE)+avrV*THMOVE
      XNEW(NE)=XNEW(NE)/XMID 
!      
      IF(XNEW(NE).LE.XMIN)XNEW(NE)=XMIN
      IF(XNEW(NE).GE.XMAX)XNEW(NE)=XMAX
      TVOL=TVOL+XNEW(NE)*pow1(ne)
  405 CONTINUE 
      IF(DABS(XU-XL).LE.EP)GOTO 410       
      IF((TVOL-VOLFRAC).GT.0.0)THEN
      XL=XMID
      ELSE
      XU=XMID
      ENDIF
      GOTO 409
  410 CONTINUE
!
      DO 406 NE=1,lopt
      TH(NE)=XNEW(NE)
  406 CONTINUE    
      do NE=lopt+1,lel
      TH(NE)=1.0
      enddo    
	open(99,file='THnew')
	do NE=1,LEL,1
      write(99,*)TH(NE)
	end do
      close (99)
      do NE=1,lel
	YOUNG(NE)=(TH(NE)**PENAL)*YOUNG01
	end do
!     input file for Ansys
	open(66,file='input_E')
	do NE=1,LEL,1
      write(66,fmt='("MP,EX,",i8,",",f40.20)')NE,YOUNG(NE) 
      end do
      close (66)
!
      NUMITER=NUMITER+1
      open(77,file='iter') 
      write(77,*)NUMITER
      close (77)
!     the end file for batch
      if (NUMITER.ge.licziter) then 
      open(88,file='end')
      close (88)
      end if
!
      end program

